#include<pic.h>
#include"hd44780.h"
#include"param.h
void LCDclk(){
	LCD_E=1;
	__delay_us(50);
	LCD_E=0;
	__delay_us(50);
}

void LCDinit(){
	//SOFTWARE RESET
	__delay_ms(50);
	LCD_RS=0;
	LCD_PORT=0x30;LCDclk();
	__delay_ms(5);
	LCD_PORT=0x30;LCDclk();
	__delay_us(200);
	LCD_PORT=0x30;LCDclk();
	//INIT 
	LCD_PORT=0x20;LCDclk();
	LCDcontrol(0x2C);// > 1 line, 4 bit
	LCDcontrol(0x0F);//LCD on, CURSOR on, CUESOR BLINKING on
	LCDcontrol(0x14);//MOVE CURSOR, no shifting
	LCDhome();
}	
	
void LCDdata(char c){
	LCD_PORT=c&0xf0;
	LCD_RS=1;	LCDclk();
	LCD_PORT=c<<4;
	LCD_RS=1;	LCDclk();
}

void LCDcontrol(char c){
	LCD_PORT=c&0xf0;
	LCD_RS=0;	LCDclk();
	LCD_PORT=c<<4;
	LCD_RS=0;	LCDclk();	
}	

void LCDprint(char *p){
	while(*p){
		LCDdata(*p);
		p++;
	}
}	

void LCDpos(char x, char y){
	LCDcontrol(0x80+0x40*(x&0x01)+LCD_WIDTH*((x&0x02)>>1)+y);
}	

void LCDhome(){
	LCDcontrol(0x01);
	__delay_ms(2);
}

void LCDvalue(char v){
	LCDdata(0x30+(v/100));
	LCDdata(0x30+((v/10)%10));
	LCDdata(0x30+(v%10));
}	

void LCDcustomCar(char carnumber, char * car){
	LCDcontrol(0x40+0x08*carnumber);
	for(char i=0;i<8;i++){
		LCDdata(car[i]);
	}
}		